// interpréteur coffeescript
// logiciel libre, sous licence CeCILL:
// http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt
// Auteurs:
// Alain Busser
// Florian Tobé
//
function alerte(c){
	alert(c);
}
var message='';
function affect(){
	message="En coffeescript, l'affectation est notée par un =.\n";
	message+="Par exemple, x=2 met 2 dans x\n";
	message+="puis x=x+1 met 3 dans x.\n";
	message+="Une variable peut être affectée par un nombre\n";
	message+="mais aussi par du texte, une liste ou même une fonction.\n"
	message+="On peut affecter simultanément a par 1 et b par 2\n";
	message+="avec [a,b]=[1,2].\n";
	message+="Pour augmenter x de 1, on peut faire x++.\n";
	alerte(message);
}
function hasard(){
	message="alea() simule un nombre pseudoaléatoire de [0;1[.\n";
	message+="Pour simuler le lancer d'un dé à n faces,\n";
	message+="entrer dé n; par exemple,\n";
	message+="pour lancer un dé à 6 faces, faire dé 6.\n";
	message+="Pour lancer 10 fois un tel dé:\n";
	message+="(dé 6 for n in [1..10])\n";
	message+="Pour jouer à pile ou face, on lance un dé à deux faces."
	alerte(message);
}
function entrees(){
	message="Pour entrer la valeur 3 dans x,\n";
	message+="le plus simple est d'affecter 3 à x avec x=3\n";
	message+="directement dans le script.\n"
	message+="Cependant, on peut écrire \n";
	message+="x=entre(\"veuillez entrer x\")";
	alerte(message);
}
function sorties(){
	message="Pour connaître la valeur d'une variable x,\n";
	message+="on doit afficher ce contenu; on peut le faire\n";
	message+="*avec alert x qui ouvre une boîte modale affichant x;\n";
	message+="*avec affiche x qui affiche x dans la fenêtre de sortie,\n";
	message+="en allant à la ligne.\n\n";
	message+="On peut insérer le contenu d'une variable dans du texte:\n";
	message+="x=2\n";
	message+="affiche \"Maintenant x contient #{x}\"\n";
	message+="x=x+1\n";
	message+="affiche \"Maintenant x contient #{x}\"\n";
	message+="x=x*x\n";
	message+="affiche \"Maintenant x contient #{x}\"\n";
	alerte(message);
}
function relations(){
	message="En CoffeeScript, les intervalles sont composés uniquement d'entiers.\n";
	message+="L'intervalle fermé [a;b] se note [a..b] avec deux points;\n";
	message+="L'intervalle ouvert à droite [a;b[ se note [a...b] avec trois points;\n";
	message+="L'appartenance se note in;\n";
	message+="Pour vérifier que 2 est compris entre 0 et 5:\n";
	message+="2 in [0..5]    renvoie true\n";
	message+="0<2<5 fait pareil d'ailleurs\n";
	message+="L'appartenance est aussi utilisée pour appliquer \n";
	message+="une fonction à un intervalle:\n";
	message+="(x*x for x in [0..5])\n";
	message+="Pour ajouter un élement x à un ensemble A:\n";
	message+="A.push x\n";
	message+="Pour enlever le nombre 5 d'un ensemble A:\n";
	message+="A = (x for x in A if x isnt 5)";
	alerte(message);
}
function logique(){
	message="L'égalité se note is (ou ==), ainsi 2+2 is 5 donne false...\n";
	message+="La négation se note not (!).\n";
	message+="par exemple, not 2+2==5 donne true\n";
	message+="aussi, not 2+2 is 5 peut s'écrire 2+2 isnt 5\n";
	message+="parce que 2+2 n'est pas égal à 5.\n";
	message+="2+2!=5 a le même effet.\n";
	message+="La conjonction se note and ou &&,\n";
	message+="et la disjonction se note or ou ||\n";
	message+=" (AltGr et le 6 du haut du clavier)";
	alerte(message);
}
function tests(){
	message="Un test est une instruction conditionnelle;\n";
	message+="Pour n'effectuer quelque chose que lorsqu'une condition\n";
	message+="est vraie, faire\n";
	message+="if dé(6)==6\n";
	message+="    affiche \"gagné\"\n";
	message+="Remarque: affiche \"gagné\" if dé(6)==6 a le même effet.\n";
	message+="Pour gérer les autres cas, faire\n";
	message+="if dé(6)==6\n";
	message+="    affiche \"gagné\"\n";
	message+="else\n";
	message+="    affiche \"perdu\"\n";
	message+="On peut faire des tests dans des intervalles\n";
	message+="avec when:\n";
	message+="(x for x in [1..12] when x%2==0)";
	alerte(message)
}
function intervalles(){
	message="L'intersection de deux ensembles A et B\n";
	message+="est formée des x de A qui sont aussi dans B:\n";
	message+="I=(x for x in A when x in B)\n";
	message+="À noter:\n";
	message+="(x for x in A when x not in B)\n";
	message+="est le complémentaire de B dans A.\n";
	message+="En probabilités, cette notion formalise le\n";
	message+="contraire d'un évènement.\n";
	message+="La réunion de deux intervalles n'est pas nécessairement\n";
	message+="un intervalle:\n";
	message+="A=(x for x in [0..100] when 2<x<15 or 80<=x<90)\n";
	message+="affiche A";
	alerte(message);
}
function infini(){
	message="Si on divise 0 par 0 on obtient NaN\n";
	message+="(not a number) qui signifie que la division n'a pas de sens.\n";
	message+="Mais si on divise 1 (ou tout autre nombre non nul) par 0,\n";
	message+="on obtient Infinity, ce qui veut dire que lorsqu'une variable x\n";
	message+="tend vers 0, son inverse 1/x tend vers l'infini;\n";
	message+="De même, 1/Infinity donne 0: Si une variable x tend vers l'infini,\n";
	message+="son inverse 1/x tend vers 0.\n";
	message+="Si on additionne l'infini à l'infini, on trouve l'infini;\n";
	message+="Si on additionne 3 à l'infini, on trouve l'infini;\n";
	message+="Mais si on tente de soustraire l'infini à l'infini,\n";
	message+="on a NaN qui, ici, désigne une forme indéterminée...";
	alerte(message);
}
function fonctions(){
	message="Une fonction associe à une variable d'entrée (ou plusieurs)\n";
	message+="appelée antécédent, une (ou plusieurs) variable de sortie\n";
	message+="appelée image; l'image de x par la fonction f est notée f(x);\n";
	message+="Aussi, en CoffeeScript, une fonction est-elle désignée par une\n";
	message+="flèche -> séparant l'antécédent, entre parenthèses, de l'image,\n";
	message+="qui est une expression. Après la flèche on peut insérer un algorithme\n";
	message+="destiné à calculer la fonction par algorithme.\n";
	message+="La dernière ligne écrite dans la fonction est la valeur retournée.\n";
	message+="Une fonction peut ne pas avoir d'antécédent, dans ce cas c'est une procédure.\n\n";
	message+="(x) -> 3 est une fonction constante;\n";
	message+="(x) -> x/2+1 est une fonction affine;\n";
	message+="On peut affecter une variable par une fonction comme dans\n";
	message+="f = (x) ->\n";
	message+="    x*x-2*x-1\n\n";
	message+="Ensuite on peut entrer f(3) ou f 3 pour avoir l'image de 3 par f.";
	alerte(message);
}
function boucles(){
	message="Pour répéter 10 fois une action, on a besoin d'une variable appelée\n";
	message+="indice de la boucle. Ici on notera i cet indice, qui ira de 1 à 10.\n";
	message+="Par exemple, pour lancer un dé 10 fois, on peut entrer\n";
	message+="for i in [1..10]\n";
	message+="    affiche dé 6\n";
	message+="Un bon moyen de suivre l'indice d'une boucle est d'afficher\n";
	message+="celui-ci dans la boucle:\n";
	message+="for in in [1..10]\n";
	message+="    affiche i\n";
	message+="Remarque:\n";
	message+="affiche i for i in [1..10]\n";
	message+="a le même effet...\n";
	message+="Pour faire descendre l'indice (compte à rebours) on peut faire\n";
	message+="affiche i for i in [10..1]\n";
	message+="Pour aller de 3 en 3 on peut faire\n";
	message+="affiche i for i in [1..10] when i%3 is 1\n";
	message+="ou, mieux:\n";
	message+="affiche i for i in [1..10] by 3\n";
	message+="Pour boucler sur les nombres premiers inférieurs à 20:\n";
	message+="for i in [2,3,5,7,11,13]";
	alerte(message);
}
function condsortie(){
	message="Pour répéter une action jusqu'à satisfaction,\n";
	message+="on utilise une boucle à condition de sortie.\n";
	message+="Pour lancer un dé jusqu'à ce qu'on ait un 6 (et compter les\n";
	message+="lancers dans un indice i), on fait\n"
	message+="i=0\n";
	message+="i++ until dé(6) is 6\n";
	message+="Une variante:\n";
	message+="i=1\n";
	message+="i++ while dé(6) isnt 6\n";
	message+="Ou, plus classique:\n";
	message+="i=1\n";
	message+="while dé(6) isnt 6\n";
	message+="    i=i+1\n";
	alerte(message);
}
function stats(){
	message="Pour trier une liste L dans l'ordre croissant:\n";
	message+="L.sort (x,y)->(x>y)\n";
	message+="Pour la trier dans l'ordre décroissant:\n";
	message+="L.sort (x,y)->(x<y)\n";
	message+="Pour compter le nombre d'éléments d'une liste L:\n";
	message+="L.length\n";
	message+="Pour connaître le maximum d'un ensemble L:\n";
	message+="Math.max.apply  null,L\n";
	message+="Pour le minimum c'est\n";
	message+="Math.min.apply  null,L\n";
	message+="Pour additionner les éléments de L:\n";
	message+="somme=0\n";
	message+="for e in L\n";
	message+="    somme+=e\n";
	alerte(message);
}
function Heron(){
	message="Calcul de la racine de 5 par l'algorithme de Heron:\n";
	message+="[a,b]=[1,5]\n";
	message+="until (abs b-a)<1e-16\n";
	message+="    a=(a+b)/2\n";
	message+="    b=5/a\n";
	message+="    affiche a";
	alerte(message);
}
function euclide(){
	message="Pour l'algorithme d'Euclide:\n";
	message+="pgcd = (a,b) ->\n";
	message+="    [x,y]=[a,b]\n";
	message+="    while y>0\n";
	message+="        [x,y]=[y,x%y]\n";
	message+="    x\n";
	message+="\n";
	message+="affiche pgcd 55,34";
	alerte(message);
}
function suiteGeom(){
	message="Combien de fois faut-il lancer un dé pour que la probabilité\n";
	message+="d'avoir au moins une fois un 6 dépasse 0,99?\n";
	message+="\n";
	message+="p=1\n";
	message+="n=1\n";
	message+="until p<0.01\n";
	message+="    p*=5/6\n";
	message+="    n++\n";
	message+="    affiche \"En lançant #{n} fois le dé, la probabilité d'avoir un 6 est #{1-p}\"\n";
	alerte(message);
}
function fibo(){
	message="Pour calculer les nombres de Fibonacci:\n";
	message+="[a,b]=[1,1]\n";
	message+="for n in [1..10]\n";
	message+="    [a,b]=[a+b,a]\n";
	message+="    affiche \"F(#{n})=#{b}\"\n";
	alerte(message);
}
function toscane(){
	message="Problème du Grand-Duc de Toscane:\n";
	message+="On lance trois dés et on additionne les résultats;\n";
	message+="Quel est le résultat le plus probable, entre 9 et 10?\n";
	message+="Simulation:\n"
	message+="effectifs=(0 for n in [3..18])\n";
	message+="for n in [1..100000]\n";
	message+="    effectifs[dé(6)+dé(6)+dé(6)-3]++\n";
	message+="affiche \"Le 9 est sorti #{effectifs[6]} fois\"\n";
	message+="affiche \"Le 10 est sorti #{effectifs[7]} fois\"\n";
	message+="\n";
	message+="Théorie:\n";
	message+="effectifs = (0 for n in [3..18])\n";
	message+="for a in [1..6]\n";
	message+="    for b in [1..6]\n";
	message+="        for c in [1..6]\n";
	message+="            effectifs[a+b+c-3]++\n";
	message+="d = puissance 6,3\n";
	message+="affiche \"La probabilité d'avoir un 9 est #{effectifs[6]/d}\"\n";
	message+="affiche \"La probabilité d'avoir un 10 est #{effectifs[7]/d}\"\n";
	alert(message);
}
function mere(){
	message="Problème du chevalier de Méré:\n";
	message+="Quelle est la probabilité d'avoir un 6 en lançant 4 dés?\n";
	message+="\n";
	message+="Simulation:\n";
	message+="gains=0\n";
	message+="for n in [1..100000]\n";
	message+="    jeu=(dé(6) for n in [1..4])\n";
	message+="    if (x for x in jeu when x is 6).length\n";
	message+="        gains++\n";
	message+="affiche gains/100000\n";
	message+="\n";
	message+="Théorie:\n";
	message+="gains=0\n";
	message+="for a in [1..6]\n";
	message+="    for b in [1..6]\n";
	message+="        for c in [1..6]\n";
	message+="            for d in [1..6]\n";
	message+="                if a is 6 or b is 6 or c is 6 or d is 6\n";
	message+="                    gains++\n";
	message+="d = puissance 6,4\n";
	message+="affiche gains/d";
	alerte(message);
}
function poker(){
	message="Simulation d'un échantillonnage\n";
	message+="  (tirage avec remise)\n";
	message+="couleur=['\u2662','\u2661','\u2664','\u2667']\n";
	message+="valeur=['1','7','8','9','10','V','D','R']\n";
	message+="jeu=[]\n";
	message+="for c in couleur\n";
	message+="    for v in valeur\n";
	message+="      jeu.push \"#{v}#{c}\"\n";
	message+="main=[]\n";
	message+="for n in [1..5]\n";
	message+="    main.push jeu[dé(32)-1]\n";
	message+="affiche main";
	alerte(message);
}
